#version 120

//go to line 96 for changing sunlight/ambient color balance

varying vec4 texcoord;
varying vec3 lightVector;
varying vec3 sunlight_color;
varying vec3 ambient_color;
varying float handItemLight;

uniform vec3 sunPosition;
uniform vec3 moonPosition;
uniform int worldTime;
uniform int heldItemId;
uniform int heldBlockLightValue;
uniform float rainStrength;
uniform float wetness;


	////////////////////sunlight color////////////////////
	////////////////////sunlight color////////////////////
	////////////////////sunlight color////////////////////
	const ivec4 ToD[25] = ivec4[25](ivec4(0,2,4,8), //hour,r,g,b
							ivec4(1,2,4,8),
							ivec4(2,2,4,8),
							ivec4(3,2,4,8),
							ivec4(4,2,4,8),
							ivec4(5,3,5,8),
							ivec4(6,300,70,25),
							ivec4(7,255,203,88),
							ivec4(8,255,212,105),
							ivec4(9,255,213,118),
							ivec4(10,275,225,205),
							ivec4(11,275,275,275),
							ivec4(12,275,275,275),
							ivec4(13,275,275,275),
							ivec4(14,265,225,175),
							ivec4(15,255,210,115),
							ivec4(16,255,205,97),
							ivec4(17,255,190,75),
							ivec4(18,255,70,25),
							ivec4(19,34,29,40),
							ivec4(20,2,4,8),
							ivec4(21,2,4,8),
							ivec4(22,2,4,8),
							ivec4(23,2,4,8),
							ivec4(24,2,4,8));

	////////////////////ambient color////////////////////
	////////////////////ambient color////////////////////
	////////////////////ambient color////////////////////
	const ivec4 ToD2[25] = ivec4[25](ivec4(0,3,12,38), //hour,r,g,b
							ivec4(1,3,12,38),
							ivec4(2,3,12,38),
							ivec4(3,3,12,38),
							ivec4(4,3,12,38),
							ivec4(5,52,112,170),
							ivec4(6,168,208,265),
							ivec4(7,169,212,265),
							ivec4(8,170,217,268),
							ivec4(9,172,228,277),
							ivec4(10,198,243,287),
							ivec4(11,218,258,298),
							ivec4(12,228,260,307),
							ivec4(13,218,258,298),
							ivec4(14,198,243,287),
							ivec4(15,155,223,273),
							ivec4(16,137,202,251),
							ivec4(17,128,187,248),
							ivec4(18,42,50,98),
							ivec4(19,42,50,98),
							ivec4(20,3,12,38),
							ivec4(21,3,12,38),
							ivec4(22,3,12,38),
							ivec4(23,3,12,38),
							ivec4(24,3,12,38));

//////////////////////////////main//////////////////////////////
//////////////////////////////main//////////////////////////////
//////////////////////////////main//////////////////////////////
//////////////////////////////main//////////////////////////////
//////////////////////////////main//////////////////////////////
void main() {
	
	gl_Position = ftransform();
	
	texcoord = gl_MultiTexCoord0;

	if (worldTime < 12700 || worldTime > 23250) {
		lightVector = normalize(sunPosition);
	}
	
	else {
		lightVector = normalize(moonPosition);
	}

	handItemLight = 0.0;
	if (heldItemId == 50) {
		// torch
		handItemLight = 0.5;
	}
	
	else if (heldItemId == 76 || heldItemId == 94) {
		// active redstone torch / redstone repeater
		handItemLight = 0.1;
	}
	
	else if (heldItemId == 89) {
		// lightstone
		handItemLight = 0.6;
	}
	
	else if (heldItemId == 10 || heldItemId == 11 || heldItemId == 51) {
		// lava / lava / fire
		handItemLight = 0.5;
	}
	
	else if (heldItemId == 91) {
		// jack-o-lantern
		handItemLight = 0.6;
	}
	
	
	else if (heldItemId == 327) {
		handItemLight = 0.2;
	}

	

	float hour = worldTime/1000.0+6.0;
	if (hour > 24.0) hour = hour - 24.0;

							
	ivec4 temp = ToD[int(floor(hour))];
	ivec4 temp2 = ToD[int(floor(hour)) + 1];
	
	sunlight_color = mix(vec3(temp.yzw),vec3(temp2.yzw),(hour-float(temp.x))/float(temp2.x-temp.x))/255.0f;
	
	

							
	ivec4 tempa = ToD2[int(floor(hour))];
	ivec4 tempa2 = ToD2[int(floor(hour)) + 1];
	
	ambient_color = mix(vec3(tempa.yzw),vec3(tempa2.yzw),(hour-float(tempa.x))/float(tempa2.x-tempa.x))/255.0f;
	
	vec3 ambient_color_rain = vec3(0.2, 0.2, 0.2); //rain

	//ambient_color.g *= 1.2;
	ambient_color = sqrt(pow(mix(ambient_color, ambient_color_rain, rainStrength*0.75),vec3(2.0))*2.0*ambient_color); //rain
	
}
