#version 120

varying vec4 texcoord;

varying vec2 lightPos;
varying vec2 moonPos;

uniform mat4 gbufferProjection;

uniform vec3 sunPosition;
uniform vec3 moonPosition;

//////////////////////////////main//////////////////////////////

void main() {
    gl_Position = gl_ProjectionMatrix * gl_ModelViewMatrix * gl_Vertex;
    
    texcoord = gl_MultiTexCoord0;
    
    vec4 tpos = vec4(sunPosition, 1.0f) * gbufferProjection;
    lightPos = (tpos.xy / tpos.z) * 0.5f + 0.5f;
    
    vec4 spos = vec4(moonPosition, 1.0f) * gbufferProjection;
    moonPos = (spos.xy / spos.z) * 0.5f + 0.5f;
}

//////////////////////////////main//////////////////////////////
