#version 120

varying vec4 color;
varying vec4 texcoord;
varying vec4 lmcoord;

uniform float frameTimeCounter;

void main() {
	texcoord = gl_TextureMatrix[0] * gl_MultiTexCoord0;
	
	vec4 position = gl_ModelViewMatrix * gl_Vertex;
			
	float distanceSquared = position.x * position.x + position.z * position.z;
	
	position.y += 5*sin(distanceSquared*sin(float(frameTimeCounter*20 + 36000)/143.0)/1000);
			
	float y = position.y;
	float x = position.x;
		
	float om = sin(distanceSquared*sin(float(frameTimeCounter*20 + 36000)/256.0)/5000) * sin(float(frameTimeCounter*20 + 36000)/200.0);
		
	position.y = x*sin(om)+y*cos(om);
	position.x = x*cos(om)-y*sin(om);
	
	gl_Position = gl_ProjectionMatrix * position;
	
	color = gl_Color;
	
	lmcoord = gl_TextureMatrix[1] * gl_MultiTexCoord1;
	
	gl_FogFragCoord = gl_Position.z;
}