// Jelly World shader that makes everything shake and wobble. Beware of motion sickness!
// By Beed28

#version 120 // This will always get moved to the top of the code in pre-processing.

varying vec4 texcoord;
varying vec4 color;
varying vec4 lmcoord;

attribute vec4 mc_Entity;

uniform float frameTimeCounter;
uniform vec3 cameraPosition;
uniform mat4 gbufferModelView;
uniform mat4 gbufferModelViewInverse;

void main() {
	
	texcoord = gl_TextureMatrix[0] * gl_MultiTexCoord0;
	vec4 position = gl_ModelViewMatrix * gl_Vertex;
	
	position = gbufferModelViewInverse * position;
	vec3 worldpos = position.xyz + cameraPosition;
	
	float PI = 3.14159265358979323846264;
	
	position.y += 0.18;
	
	if (gl_Color.a != 0.8) {
               
				float magnitude = sin(frameTimeCounter / 4.0) + 10.0 * sin(frameTimeCounter / 4.0) - 18.0;
				float premagnitude = sin(frameTimeCounter / 4.0) + 4.0 * sin(frameTimeCounter / 4.0) - 18.0;
				float distanceSquared = position.x * position.x + position.z * position.z + position.y * position.y;
				
				position.y += 4.5*sin(sin(frameTimeCounter/0.5) * atan(distanceSquared / 800.0))/3.0 * premagnitude/20.0;
				
				if (gl_Color.a != 0.0) {
					float z = position.z;
					float x = position.x;
					float om = sin(2.0 * PI * (frameTimeCounter / 1.34 + (worldpos.x) / 256.0)) / 12.0 * premagnitude / 224.0;
					position.z = x*sin(om)+z*cos(om);
					position.x = x*cos(om)-z*sin(om);
					}
				if (gl_Color.a != 0.0) {
					float y = position.y;
					float x = position.x;
					float om = cos(2.0 * PI * (frameTimeCounter / 0.32 + (worldpos.x + -worldpos.y) / 320.0)) / 12.0 * magnitude / 224.0;
					position.y = x*sin(om)+y*cos(om);
					position.x = x*cos(om)-y*sin(om);
					}
				if (gl_Color.a != 0.0) {
					float y = position.y;
					float z = position.z;
					float om = cos(2.0 * PI * (frameTimeCounter / 0.31 + (worldpos.z + -worldpos.y) / 320.0)) / 12.0 * magnitude / 224.0;
					position.y = z*sin(om)+y*cos(om);
					position.z = z*cos(om)-y*sin(om);
					}
				if (gl_Color.a != 0.0) {
					float y = position.y;
					float x = position.x;
					float om = cos(2.0 * PI * (frameTimeCounter / 0.43 + (-worldpos.x + -worldpos.y) / 320.0)) / 12.0 * magnitude / 224.0;
					position.y = x*sin(om)+y*cos(om);
					position.x = x*cos(om)-y*sin(om);
					}
				if (gl_Color.a != 0.0) {
					float y = position.y;
					float z = position.z;
					float om = cos(2.0 * PI * (frameTimeCounter / 0.44 + (-worldpos.z + -worldpos.y) / 320.0)) / 12.0 * magnitude / 224.0;
					position.y = z*sin(om)+y*cos(om);
					position.z = z*cos(om)-y*sin(om);
					}
				if (gl_Color.a != 0.0) {
					float x = position.x;
					float z = position.z;
					float om = sin(2.0 * PI * (frameTimeCounter / 0.30 + (-worldpos.y) / 176.0)) / 12.0 * premagnitude / 224.0;
					position.x = z*sin(om)+x*cos(om);
					position.z = z*cos(om)-x*sin(om);
					}
				
				position.y += sin(sin(frameTimeCounter/0.042-0.65)     + sin(distanceSquared/9999.0) / 2.0) * premagnitude/80.0;
				position.z += 1.2*sin(sin(frameTimeCounter/0.07)     + sin(distanceSquared/9999.0) / 2.0) * magnitude/192.0;
				position.x += 1.2*sin(sin(frameTimeCounter/0.08)     + sin(distanceSquared/9999.0) / 2.0) * magnitude/192.0;
		}

	position = gbufferModelView * position;
	
	gl_Position = gl_ProjectionMatrix * position;
		
	color = gl_Color;
	
	texcoord = gl_TextureMatrix[0] * gl_MultiTexCoord0;

	lmcoord = gl_TextureMatrix[1] * gl_MultiTexCoord1;
	
	gl_FogFragCoord = gl_Position.z;
}