// Jelly World shader that makes everything shake and wobble. Beware of motion sickness!
// By Beed28

#version 120 // This will always get moved to the top of the code in pre-processing.

//Note: If Jelly World is a bit slow, try disabling some of these.
#define WAVING_GRASS
#define WAVING_SAPLINGS
#define WAVING_DEAD_BUSH
#define WAVING_FLOWERS
#define WAVING_WHEAT
#define WAVING_WART
#define WAVING_LEAVES
#define WAVING_VINES
#define WAVING_SUGAR_CANE
#define WAVING_LARGE_FLOWERS
#define WAVING_COBWEBS

//Just for fun, note that entities, particles, and the block highlight box won't match up with this. 
//#define LITERAL_JELLY_MODE

varying vec4 texcoord;
varying vec4 color;
varying vec4 lmcoord;

attribute vec4 mc_Entity;

uniform float frameTimeCounter;
uniform vec3 cameraPosition;
uniform mat4 gbufferModelView;
uniform mat4 gbufferModelViewInverse;

void main() {
	
	texcoord = gl_TextureMatrix[0] * gl_MultiTexCoord0;
	vec4 position = gl_ModelViewMatrix * gl_Vertex;
	
	position = gbufferModelViewInverse * position;
	vec3 worldpos = position.xyz + cameraPosition;
	
	bool istopv = gl_MultiTexCoord0.t < gl_MultiTexCoord3.t;
	float PI = 3.14159265358979323846264;
	
	position.y += 0.15;
	
	if (gl_Color.a != 0.8) {
               
				float magnitude = sin(frameTimeCounter / 4.0) + 10.0 * sin(frameTimeCounter / 4.0) - 18.0;
				float premagnitude = sin(frameTimeCounter / 4.0) + 4.0 * sin(frameTimeCounter / 4.0) - 18.0;
				float distanceSquared = position.x * position.x + position.z * position.z + position.y * position.y;
				
				position.y += 4.5*sin(sin(frameTimeCounter/0.5) * atan(distanceSquared / 800.0))/3.0 * premagnitude/20.0;
				
				if (gl_Color.a != 0.0) {
					float z = position.z;
					float x = position.x;
					float om = sin(2.0 * PI * (frameTimeCounter / 1.34 + (worldpos.x) / 256.0)) / 12.0 * premagnitude / 224.0;
					position.z = x*sin(om)+z*cos(om);
					position.x = x*cos(om)-z*sin(om);
					}
				if (gl_Color.a != 0.0) {
					float y = position.y;
					float x = position.x;
					float om = cos(2.0 * PI * (frameTimeCounter / 0.32 + (worldpos.x + -worldpos.y) / 320.0)) / 12.0 * magnitude / 224.0;
					position.y = x*sin(om)+y*cos(om);
					position.x = x*cos(om)-y*sin(om);
					}
				if (gl_Color.a != 0.0) {
					float y = position.y;
					float z = position.z;
					float om = cos(2.0 * PI * (frameTimeCounter / 0.31 + (worldpos.z + -worldpos.y) / 320.0)) / 12.0 * magnitude / 224.0;
					position.y = z*sin(om)+y*cos(om);
					position.z = z*cos(om)-y*sin(om);
					}
				if (gl_Color.a != 0.0) {
					float y = position.y;
					float x = position.x;
					float om = cos(2.0 * PI * (frameTimeCounter / 0.43 + (-worldpos.x + -worldpos.y) / 320.0)) / 12.0 * magnitude / 224.0;
					position.y = x*sin(om)+y*cos(om);
					position.x = x*cos(om)-y*sin(om);
					}
				if (gl_Color.a != 0.0) {
					float y = position.y;
					float z = position.z;
					float om = cos(2.0 * PI * (frameTimeCounter / 0.44 + (-worldpos.z + -worldpos.y) / 320.0)) / 12.0 * magnitude / 224.0;
					position.y = z*sin(om)+y*cos(om);
					position.z = z*cos(om)-y*sin(om);
					}
				if (gl_Color.a != 0.0) {
					float x = position.x;
					float z = position.z;
					float om = sin(2.0 * PI * (frameTimeCounter / 0.30 + (-worldpos.y) / 176.0)) / 12.0 * premagnitude / 224.0;
					position.x = z*sin(om)+x*cos(om);
					position.z = z*cos(om)-x*sin(om);
					}
				
				if ((mc_Entity.x == 31.0 && istopv) || //Grass
					(mc_Entity.x == 32.0 && istopv) || //Dead bush
					(mc_Entity.x == 37.0 && istopv) || //Dandelion
					(mc_Entity.x == 38.0 && istopv) || //Rose
					(mc_Entity.x == 39.0 && istopv) || //Brown Mushroom
					(mc_Entity.x == 40.0 && istopv) || //Red Mushroom
					(mc_Entity.x == 51.0 && istopv) || //Fire
					(mc_Entity.x == 59.0 && istopv) || //Wheat
					(mc_Entity.x == 106.0) || //Vines
					(mc_Entity.x == 18.0) || //Leaves
					(mc_Entity.x == 161.0) || //Leaves
					(mc_Entity.x == 78.0) || //Snow
					(mc_Entity.x == 83.0) || //Sugar Cane
					(mc_Entity.x == 175.0) || //Large Flowers
					(mc_Entity.x == 115.0 && istopv) || //Nether Wart
					(mc_Entity.x == 141.0 && istopv) || //Carrots
					(mc_Entity.x == 142.0 && istopv) || //Potatoes
					(mc_Entity.x == 06.0 && istopv)) //Saplings
						{if (mc_Entity.x != 78.0)
							{
							if (mc_Entity.x != 18.0)
								{
								if (mc_Entity.x != 161.0)
									{
									if (mc_Entity.x != 106.0)
										{
										if (mc_Entity.x != 83.0)
											{
											if (mc_Entity.x != 175.0)
												{position.y += sin(sin(frameTimeCounter/0.042-0.8)     + sin(distanceSquared/9999.0) / 2.0) * premagnitude/80.0;}
											if (mc_Entity.x == 175.0)	
												{position.y += sin(sin(frameTimeCounter/0.042-0.5)     + sin(distanceSquared/9999.0) / 2.0) * premagnitude/80.0;
												position.y -= 0.1;}
											}
										if (mc_Entity.x == 83.0)
											{position.y += sin(sin(frameTimeCounter/0.042-0.5)     + sin(distanceSquared/9999.0) / 2.0) * premagnitude/80.0;
											position.y -= 0.1;}
										}
									if (mc_Entity.x == 106.0)
										{position.y += sin(sin(frameTimeCounter/0.042-0.21)     + sin(distanceSquared/9999.0) / 2.0) * premagnitude/80.0;}
									}
								if (mc_Entity.x == 161.0)
									{position.y += sin(sin(frameTimeCounter/0.042-0.21)     + sin(distanceSquared/9999.0) / 2.0) * premagnitude/80.0;
									position.y -= 0.055;}
								}
							if (mc_Entity.x == 18.0)
								{position.y += sin(sin(frameTimeCounter/0.042-0.21)     + sin(distanceSquared/9999.0) / 2.0) * premagnitude/80.0;
								position.y -= 0.055;}
							}
						if (mc_Entity.x == 78.0)
							{position.y += sin(sin(frameTimeCounter/0.042-0.21)     + sin(distanceSquared/9999.0) / 2.0) * premagnitude/80.0;
							position.y -= 0.055;}}
				else
					{position.y += sin(sin(frameTimeCounter/0.042)         + sin(distanceSquared/9999.0) / 2.0) * premagnitude/80.0;}
				
				position.z += 1.2*sin(sin(frameTimeCounter/0.07)     + sin(distanceSquared/9999.0) / 2.0) * magnitude/192.0;
				position.x += 1.2*sin(sin(frameTimeCounter/0.08)     + sin(distanceSquared/9999.0) / 2.0) * magnitude/192.0;
				
				//Water would splash about like crazy when your whole world is shaking like jelly. :)
				if (mc_Entity.x == 09.0 || mc_Entity.x == 111.0) {
					position.y += 0.14 * sin(6.0 * PI * (frameTimeCounter / 1.29 + worldpos.x / 25.0  + worldpos.z / 24.0));
					position.y += 0.14 * sin(6.0 * PI * (frameTimeCounter / 1.49 + worldpos.x / 27.0  + -worldpos.z / 26.0));
					position.y += 0.14 * sin(6.0 * PI * (frameTimeCounter / 1.69 + -worldpos.x / 29.0  + worldpos.z / 28.0));
					position.y -= 0.29;}
				//And lava too, to a smaller extent
				if (mc_Entity.x == 11.0) {
					position.y += 0.05 * sin(6.0 * PI * (frameTimeCounter / 1.29 + worldpos.x / 25.0  + worldpos.z / 24.0));
					position.y += 0.05 * sin(6.0 * PI * (frameTimeCounter / 1.49 + worldpos.x / 27.0  + -worldpos.z / 26.0));
					position.y += 0.05 * sin(6.0 * PI * (frameTimeCounter / 1.69 + -worldpos.x / 29.0  + worldpos.z / 28.0));
					position.y -= 0.19;}
		}

#ifdef LITERAL_JELLY_MODE
	if (gl_Color.a != 0.0) {
		float speed = 0.06;
		float magnitude = (sin(((worldpos.y + worldpos.x)/1.0 + frameTimeCounter * PI / ((0.1)))) * 0.05 + 0.15) * 0.26;
		float d0 = sin(frameTimeCounter * PI / (64.2 * speed)) * 2.0 - 1.5;
		float d1 = sin(frameTimeCounter * PI / (64.1 * speed)) * 2.0 - 1.5;
		float d2 = sin(frameTimeCounter * PI / (64.0 * speed)) * 2.0 - 1.5;
		float d3 = sin(frameTimeCounter * PI / (64.3 * speed)) * 2.0 - 1.5;
		position.x += cos((frameTimeCounter * PI / (2.0 * speed)) + (worldpos.x)*0.1 + (worldpos.z)*0.1 - (worldpos.y)) * magnitude;
		position.z += cos((frameTimeCounter * PI / (2.6 * speed)) + (worldpos.z)*0.1 + (worldpos.x)*0.1 - (worldpos.y)) * magnitude;
		position.y -= cos((frameTimeCounter * PI / (2.4 * speed)) + (worldpos.x)*0.9 + (worldpos.z)*0.9 - (worldpos.y)) * magnitude * 2.0;
	}
#endif

#ifdef WAVING_GRASS	
//Grass//
	if (mc_Entity.x == 31.0 && istopv) {
		float speed = 0.01 * 4.0;
		
		float magnitude = sin((frameTimeCounter * PI / (0.3)) + worldpos.x + worldpos.z) * 0.1 + 0.1;
		float d0 = sin(frameTimeCounter * PI / (122.0 * speed)) * 3.0 - 1.5 + worldpos.z;
		float d1 = sin(frameTimeCounter * PI / (152.0 * speed)) * 3.0 - 1.5 + worldpos.x;
		float d2 = sin(frameTimeCounter * PI / (122.0 * speed)) * 3.0 - 1.5 + worldpos.x;
		float d3 = sin(frameTimeCounter * PI / (152.0 * speed)) * 3.0 - 1.5 + worldpos.z;
		position.x += sin((frameTimeCounter * PI / (28.0 * speed)) + (worldpos.x + d0) * 0.1 + (worldpos.z + d1) * 0.1) * magnitude;
		position.z += sin((frameTimeCounter * PI / (28.0 * speed)) + (worldpos.z + d2) * 0.1 + (worldpos.x + d3) * 0.1) * magnitude;
	}
	
	//small leaf movement
	if (mc_Entity.x == 31.0 && istopv) {
		float speed = 0.01 * 4.0;
		
		float magnitude = (sin(((worldpos.y + worldpos.x)/2.0 + frameTimeCounter * PI / ((0.3)))) * 0.05 + 0.15) * 0.5; //0.4
		float d0 = sin(frameTimeCounter * PI / (212.0 * speed)) * 3.0 - 1.5;
		float d1 = sin(frameTimeCounter * PI / (242.0 * speed)) * 3.0 - 1.5;
		float d2 = sin(frameTimeCounter * PI / (212.0 * speed)) * 3.0 - 1.5;
		float d3 = sin(frameTimeCounter * PI / (242.0 * speed)) * 3.0 - 1.5;
		position.x += sin((frameTimeCounter * PI / (18.0 * speed)) + (-worldpos.x + d0)*1.6 + (worldpos.z + d1)*1.6) * magnitude;
		position.z += sin((frameTimeCounter * PI / (18.0 * speed)) + (worldpos.z + d2)*1.6 + (-worldpos.x + d3)*1.6) * magnitude;
		position.y += sin((frameTimeCounter * PI / (11.0 * speed)) + (worldpos.z + d2) + (worldpos.x + d3)) * (magnitude/3.0);
	}
	
#endif


#ifdef WAVING_SAPLINGS
//Grass//
	if (mc_Entity.x == 06.0 && istopv) {
		float speed = 0.01 * 4.0;
		
		float magnitude = sin((frameTimeCounter * PI / (0.3)) + worldpos.x + worldpos.z) * 0.1 + 0.1;
		float d0 = sin(frameTimeCounter * PI / (122.0 * speed)) * 3.0 - 1.5 + worldpos.z;
		float d1 = sin(frameTimeCounter * PI / (152.0 * speed)) * 3.0 - 1.5 + worldpos.x;
		float d2 = sin(frameTimeCounter * PI / (122.0 * speed)) * 3.0 - 1.5 + worldpos.x;
		float d3 = sin(frameTimeCounter * PI / (152.0 * speed)) * 3.0 - 1.5 + worldpos.z;
		position.x += sin((frameTimeCounter * PI / (28.0 * speed)) + (worldpos.x + d0) * 0.1 + (worldpos.z + d1) * 0.1) * magnitude;
		position.z += sin((frameTimeCounter * PI / (28.0 * speed)) + (worldpos.z + d2) * 0.1 + (worldpos.x + d3) * 0.1) * magnitude;
	}
	
	//small leaf movement
	if (mc_Entity.x == 06.0 && istopv) {
		float speed = 0.01 * 4.0;
		
		float magnitude = (sin(((worldpos.y + worldpos.x)/2.0 + frameTimeCounter * PI / ((0.3)))) * 0.05 + 0.15) * 0.5; //0.4
		float d0 = sin(frameTimeCounter * PI / (212.0 * speed)) * 3.0 - 1.5;
		float d1 = sin(frameTimeCounter * PI / (242.0 * speed)) * 3.0 - 1.5;
		float d2 = sin(frameTimeCounter * PI / (212.0 * speed)) * 3.0 - 1.5;
		float d3 = sin(frameTimeCounter * PI / (242.0 * speed)) * 3.0 - 1.5;
		position.x += sin((frameTimeCounter * PI / (18.0 * speed)) + (-worldpos.x + d0)*1.6 + (worldpos.z + d1)*1.6) * magnitude;
		position.z += sin((frameTimeCounter * PI / (18.0 * speed)) + (worldpos.z + d2)*1.6 + (-worldpos.x + d3)*1.6) * magnitude;
		position.y += sin((frameTimeCounter * PI / (11.0 * speed)) + (worldpos.z + d2) + (worldpos.x + d3)) * (magnitude/3.0);
	}
#endif


#ifdef WAVING_DEAD_BUSH
//Grass//
	if (mc_Entity.x == 32.0 && istopv) {
		float speed = 0.01 * 4.0;
		
		float magnitude = sin((frameTimeCounter * PI / (0.3)) + worldpos.x + worldpos.z) * 0.1 + 0.1;
		float d0 = sin(frameTimeCounter * PI / (122.0 * speed)) * 3.0 - 1.5 + worldpos.z;
		float d1 = sin(frameTimeCounter * PI / (152.0 * speed)) * 3.0 - 1.5 + worldpos.x;
		float d2 = sin(frameTimeCounter * PI / (122.0 * speed)) * 3.0 - 1.5 + worldpos.x;
		float d3 = sin(frameTimeCounter * PI / (152.0 * speed)) * 3.0 - 1.5 + worldpos.z;
		position.x += sin((frameTimeCounter * PI / (28.0 * speed)) + (worldpos.x + d0) * 0.1 + (worldpos.z + d1) * 0.1) * magnitude;
		position.z += sin((frameTimeCounter * PI / (28.0 * speed)) + (worldpos.z + d2) * 0.1 + (worldpos.x + d3) * 0.1) * magnitude;
	}
	
	//small leaf movement
	if (mc_Entity.x == 32.0 && istopv) {
		float speed = 0.01 * 4.0;
		
		float magnitude = (sin(((worldpos.y + worldpos.x)/2.0 + frameTimeCounter * PI / ((0.3)))) * 0.05 + 0.15) * 0.5; //0.4
		float d0 = sin(frameTimeCounter * PI / (212.0 * speed)) * 3.0 - 1.5;
		float d1 = sin(frameTimeCounter * PI / (242.0 * speed)) * 3.0 - 1.5;
		float d2 = sin(frameTimeCounter * PI / (212.0 * speed)) * 3.0 - 1.5;
		float d3 = sin(frameTimeCounter * PI / (242.0 * speed)) * 3.0 - 1.5;
		position.x += sin((frameTimeCounter * PI / (18.0 * speed)) + (-worldpos.x + d0)*1.6 + (worldpos.z + d1)*1.6) * magnitude;
		position.z += sin((frameTimeCounter * PI / (18.0 * speed)) + (worldpos.z + d2)*1.6 + (-worldpos.x + d3)*1.6) * magnitude;
		position.y += sin((frameTimeCounter * PI / (11.0 * speed)) + (worldpos.z + d2) + (worldpos.x + d3)) * (magnitude/3.0);
	}
#endif


#ifdef WAVING_FLOWERS
    //large scale movement (dandelions)
	if (mc_Entity.x == 37.0 && istopv) {
        float speed = 0.01;
        float magnitude = sin((frameTimeCounter * PI / (0.3)) + worldpos.x + worldpos.z) * 0.1 + 0.1;
        float d0 = sin(frameTimeCounter * PI / (122.0 * speed)) * 3.0 - 1.5 + worldpos.z;
        float d1 = sin(frameTimeCounter * PI / (152.0 * speed)) * 3.0 - 1.5 + worldpos.x;
        float d2 = sin(frameTimeCounter * PI / (122.0 * speed)) * 3.0 - 1.5 + worldpos.x;
        float d3 = sin(frameTimeCounter * PI / (152.0 * speed)) * 3.0 - 1.5 + worldpos.z;
        position.x += sin((frameTimeCounter * PI / (28.0 * speed)) + (worldpos.x + d0) * 0.1 + (worldpos.z + d1) * 0.1) * magnitude;
        position.z += sin((frameTimeCounter * PI / (28.0 * speed)) + (worldpos.z + d2) * 0.1 + (worldpos.x + d3) * 0.1) * magnitude;
    }
    //small scale movement (dandelions)
	if (mc_Entity.x == 37.0 && istopv) {
        float speed = 0.01;
        float magnitude = (sin(((worldpos.y + worldpos.x)/2.0 + frameTimeCounter * PI / ((0.3)))) * 0.05 + 0.15) * 0.5; //0.4
        float d0 = sin(frameTimeCounter * PI / (112.0 * speed)) * 3.0 - 1.5;
        float d1 = sin(frameTimeCounter * PI / (142.0 * speed)) * 3.0 - 1.5;
        float d2 = sin(frameTimeCounter * PI / (112.0 * speed)) * 3.0 - 1.5;
        float d3 = sin(frameTimeCounter * PI / (142.0 * speed)) * 3.0 - 1.5;
        position.x += sin((frameTimeCounter * PI / (18.0 * speed)) + (-worldpos.x + d0)*1.6 + (worldpos.z + d1)*1.6) * magnitude;
        position.z += sin((frameTimeCounter * PI / (18.0 * speed)) + (worldpos.z + d2)*1.6 + (-worldpos.x + d3)*1.6) * magnitude;
        position.y += sin((frameTimeCounter * PI / (11.0 * speed)) + (worldpos.z + d2) + (worldpos.x + d3)) * (magnitude/3.0);
    }
    //large scale movement (roses)
	if (mc_Entity.x == 38.0 && istopv) {
        float speed = 0.01;
        float magnitude = sin((frameTimeCounter * PI / (0.3)) + worldpos.x + worldpos.z) * 0.1 + 0.1;
        float d0 = sin(frameTimeCounter * PI / (122.0 * speed)) * 3.0 - 1.5 + worldpos.z;
        float d1 = sin(frameTimeCounter * PI / (152.0 * speed)) * 3.0 - 1.5 + worldpos.x;
        float d2 = sin(frameTimeCounter * PI / (122.0 * speed)) * 3.0 - 1.5 + worldpos.x;
        float d3 = sin(frameTimeCounter * PI / (152.0 * speed)) * 3.0 - 1.5 + worldpos.z;
        position.x += sin((frameTimeCounter * PI / (28.0 * speed)) + (worldpos.x + d0) * 0.1 + (worldpos.z + d1) * 0.1) * magnitude;
        position.z += sin((frameTimeCounter * PI / (28.0 * speed)) + (worldpos.z + d2) * 0.1 + (worldpos.x + d3) * 0.1) * magnitude;
    }
    //small scale movement (roses)
	if (mc_Entity.x == 38.0 && istopv) {
        float speed = 0.01;
        float magnitude = (sin(((worldpos.y + worldpos.x)/2.0 + frameTimeCounter * PI / ((0.3)))) * 0.05 + 0.15) * 0.5; //0.4
        float d0 = sin(frameTimeCounter * PI / (112.0 * speed)) * 3.0 - 1.5;
        float d1 = sin(frameTimeCounter * PI / (142.0 * speed)) * 3.0 - 1.5;
        float d2 = sin(frameTimeCounter * PI / (112.0 * speed)) * 3.0 - 1.5;
        float d3 = sin(frameTimeCounter * PI / (142.0 * speed)) * 3.0 - 1.5;
        position.x += sin((frameTimeCounter * PI / (18.0 * speed)) + (-worldpos.x + d0)*1.6 + (worldpos.z + d1)*1.6) * magnitude;
        position.z += sin((frameTimeCounter * PI / (18.0 * speed)) + (worldpos.z + d2)*1.6 + (-worldpos.x + d3)*1.6) * magnitude;
        position.y += sin((frameTimeCounter * PI / (11.0 * speed)) + (worldpos.z + d2) + (worldpos.x + d3)) * (magnitude/3.0);
    }
    #endif


#ifdef WAVING_WHEAT
//Wheat//
	if (mc_Entity.x == 59.0 && istopv) {
		float speed = 0.01 * 4.0;
		
		float magnitude = sin((frameTimeCounter * PI / (0.3)) + worldpos.x + worldpos.z) * 0.12 + 0.12;
		float d0 = sin(frameTimeCounter * PI / (122.0 * speed)) * 3.0 - 1.5 + worldpos.z;
		float d1 = sin(frameTimeCounter * PI / (152.0 * speed)) * 3.0 - 1.5 + worldpos.x;
		float d2 = sin(frameTimeCounter * PI / (122.0 * speed)) * 3.0 - 1.5 + worldpos.x;
		float d3 = sin(frameTimeCounter * PI / (152.0 * speed)) * 3.0 - 1.5 + worldpos.z;
		position.x += sin((frameTimeCounter * PI / (28.0 * speed)) + (worldpos.x + d0) * 0.1 + (worldpos.z + d1) * 0.1) * magnitude;
		position.z += sin((frameTimeCounter * PI / (28.0 * speed)) + (worldpos.z + d2) * 0.1 + (worldpos.x + d3) * 0.1) * magnitude;
	}
	
	//small leaf movement
	if (mc_Entity.x == 59.0 && istopv) {
		float speed = 0.01 * 4.0;
		
		float magnitude = (sin(((worldpos.y + worldpos.x)/2.0 + frameTimeCounter * PI / ((0.3)))) * 0.035 + 0.085) * 0.3; //0.3
		float d0 = sin(frameTimeCounter * PI / (112.0 * speed)) * 3.0 - 1.5;
		float d1 = sin(frameTimeCounter * PI / (142.0 * speed)) * 3.0 - 1.5;
		float d2 = sin(frameTimeCounter * PI / (112.0 * speed)) * 3.0 - 1.5;
		float d3 = sin(frameTimeCounter * PI / (142.0 * speed)) * 3.0 - 1.5;
		position.x += sin((frameTimeCounter * PI / (18.0 * speed)) + (-worldpos.x + d0)*1.6 + (worldpos.z + d1)*1.6) * magnitude;
		position.z += sin((frameTimeCounter * PI / (18.0 * speed)) + (worldpos.z + d2)*1.6 + (-worldpos.x + d3)*1.6) * magnitude;
		position.y += sin((frameTimeCounter * PI / (11.0 * speed)) + (worldpos.z + d2) + (worldpos.x + d3)) * (magnitude/3.0);
	}
#endif


#ifdef WAVING_WART
//Wheat//
	if (mc_Entity.x == 115.0 && istopv) {
		float speed = 0.01 * 4.0;
		
		float magnitude = sin((frameTimeCounter * PI / (0.3)) + worldpos.x + worldpos.z) * 0.12 + 0.12;
		float d0 = sin(frameTimeCounter * PI / (122.0 * speed)) * 3.0 - 1.5 + worldpos.z;
		float d1 = sin(frameTimeCounter * PI / (152.0 * speed)) * 3.0 - 1.5 + worldpos.x;
		float d2 = sin(frameTimeCounter * PI / (122.0 * speed)) * 3.0 - 1.5 + worldpos.x;
		float d3 = sin(frameTimeCounter * PI / (152.0 * speed)) * 3.0 - 1.5 + worldpos.z;
		position.x += sin((frameTimeCounter * PI / (28.0 * speed)) + (worldpos.x + d0) * 0.1 + (worldpos.z + d1) * 0.1) * magnitude;
		position.z += sin((frameTimeCounter * PI / (28.0 * speed)) + (worldpos.z + d2) * 0.1 + (worldpos.x + d3) * 0.1) * magnitude;
	}
	
	//small leaf movement
	if (mc_Entity.x == 115.0 && istopv) {
		float speed = 0.01 * 4.0;
		
		float magnitude = (sin(((worldpos.y + worldpos.x)/2.0 + frameTimeCounter * PI / ((0.3)))) * 0.035 + 0.085) * 0.3; //0.2
		float d0 = sin(frameTimeCounter * PI / (112.0 * speed)) * 3.0 - 1.5;
		float d1 = sin(frameTimeCounter * PI / (142.0 * speed)) * 3.0 - 1.5;
		float d2 = sin(frameTimeCounter * PI / (112.0 * speed)) * 3.0 - 1.5;
		float d3 = sin(frameTimeCounter * PI / (142.0 * speed)) * 3.0 - 1.5;
		position.x += sin((frameTimeCounter * PI / (18.0 * speed)) + (-worldpos.x + d0)*1.6 + (worldpos.z + d1)*1.6) * magnitude;
		position.z += sin((frameTimeCounter * PI / (18.0 * speed)) + (worldpos.z + d2)*1.6 + (-worldpos.x + d3)*1.6) * magnitude;
		position.y += sin((frameTimeCounter * PI / (11.0 * speed)) + (worldpos.z + d2) + (worldpos.x + d3)) * (magnitude/3.0);
	}
#endif


#ifdef WAVING_LEAVES
    //large scale movement
	if (mc_Entity.x == 18.0 || mc_Entity.x == 161.0) {
        float speed = 0.06;
        float magnitude = (sin(((worldpos.y + worldpos.x)/1.0 + frameTimeCounter * PI / ((0.5)))) * 0.05 + 0.15) * 0.27; //0.26
        position.x += cos((frameTimeCounter * PI / (2.0 * speed)) + (worldpos.x)*0.1 + (worldpos.z)*0.1 + (worldpos.y)) * magnitude;
        position.z += cos((frameTimeCounter * PI / (2.6 * speed)) + (worldpos.z)*0.1 + (worldpos.x)*0.1 + (worldpos.y)) * magnitude;
        position.y += cos((frameTimeCounter * PI / (2.4 * speed)) + (worldpos.x)*0.9 + (worldpos.z)*0.9 + (worldpos.y)) * magnitude * 2.0;
    }
#endif


#ifdef WAVING_VINES
    //large scale movement
	if (mc_Entity.x == 106.0) {
        float speed = 0.06;
        float magnitude = (sin(((worldpos.y + worldpos.x)/1.0 + (frameTimeCounter + 0.03) * PI / ((0.3)))) * 0.05 + 0.15) * 0.27; //0.26
        position.x += cos(((frameTimeCounter + 0.03) * PI / (2.0 * speed)) + (worldpos.x)*0.1 + (worldpos.z)*0.1 + (worldpos.y)) * magnitude;
        position.z += cos(((frameTimeCounter + 0.03) * PI / (2.6 * speed)) + (worldpos.z)*0.1 + (worldpos.x)*0.1 + (worldpos.y)) * magnitude;
        position.y += cos(((frameTimeCounter + 0.03) * PI / (2.4 * speed)) + (worldpos.x)*0.9 + (worldpos.z)*0.9 + (worldpos.y)) * magnitude;
		position.y -= 0.085;
    }
#endif


#ifdef WAVING_SUGAR_CANE
    //large scale movement
	if (mc_Entity.x == 83.0) {
        float speed = 0.06;
        float magnitude = (sin(((worldpos.y + worldpos.x)/1.0 + (frameTimeCounter + 0.03) * PI / ((0.3)))) * 0.05 + 0.15) * 0.27; //0.26
        position.x += cos(((frameTimeCounter + 0.04) * PI / (2.0 * speed)) + (worldpos.x)*0.1 + (worldpos.z)*0.1 + (-worldpos.y)) * magnitude;
        position.z += cos(((frameTimeCounter + 0.04) * PI / (2.6 * speed)) + (worldpos.z)*0.1 + (worldpos.x)*0.1 + (-worldpos.y)) * magnitude;
        position.y += cos(((frameTimeCounter + 0.04) * PI / (2.4 * speed)) + (worldpos.x)*0.9 + (worldpos.z)*0.9 + (-worldpos.y)) * magnitude;
    }
#endif


#ifdef WAVING_LARGE_FLOWERS
    //large scale movement
	if (mc_Entity.x == 175.0) {
        float speed = 0.06;
        float magnitude = (sin(((worldpos.y + worldpos.x)/1.0 + (frameTimeCounter + 0.03) * PI / ((0.3)))) * 0.05 + 0.15) * 0.27; //0.26
        position.x += cos(((frameTimeCounter + 0.02) * PI / (2.0 * speed)) + (worldpos.x)*0.1 + (worldpos.z)*0.1 + (-worldpos.y)) * magnitude;
        position.z += cos(((frameTimeCounter + 0.02) * PI / (2.6 * speed)) + (worldpos.z)*0.1 + (worldpos.x)*0.1 + (-worldpos.y)) * magnitude;
        position.y += cos(((frameTimeCounter + 0.02) * PI / (2.4 * speed)) + (worldpos.x)*0.9 + (worldpos.z)*0.9 + (-worldpos.y)) * magnitude;
    }
#endif


#ifdef WAVING_COBWEBS
    //large scale movement
	if (mc_Entity.x == 30.0) {
        float speed = 0.06;
        float magnitude = (sin(((worldpos.y + worldpos.x)/1.0 + frameTimeCounter * PI / (0.5)))) * 0.07; //0.06
        float d0 = sin(frameTimeCounter * PI / (64.2 * speed)) * 2.0 - 1.5;
        float d1 = sin(frameTimeCounter * PI / (64.1 * speed)) * 2.0 - 1.5;
        float d2 = sin(frameTimeCounter * PI / (64.0 * speed)) * 2.0 - 1.5;
        float d3 = sin(frameTimeCounter * PI / (64.3 * speed)) * 2.0 - 1.5;
        position.x += sin((frameTimeCounter * PI / (2.0 * speed)) + (worldpos.x + d0)*0.1 + (worldpos.z + d1)*0.1 + (worldpos.y)) * magnitude;
        position.z += sin((frameTimeCounter * PI / (2.6 * speed)) + (worldpos.z + d2)*0.1 + (worldpos.x + d3)*0.1 + (worldpos.y)) * magnitude;
        position.y += sin((frameTimeCounter * PI / (2.4 * speed)) + (worldpos.x + d2)*0.9 + (worldpos.z + d3)*0.9 + (worldpos.y)) * magnitude * 2.0;
    }
#endif


	position = gbufferModelView * position;
	
	gl_Position = gl_ProjectionMatrix * position;
		
	color = gl_Color;
	
	texcoord = gl_TextureMatrix[0] * gl_MultiTexCoord0;

	lmcoord = gl_TextureMatrix[1] * gl_MultiTexCoord1;
	
	gl_FogFragCoord = gl_Position.z;
}